<template>
  <div>
    <div class="row">
      <div class="col cabecera-espaciada">
        <h2>MI CARTERA</h2>
      </div>
      <div class="col-2">
        <cotizacion-dolar />
      </div>
    </div>

    <table class="table table-sm table-hover table-bordered">
      <thead class="thead-dark text-center">
        <tr>
          <th>Activo</th>
          <th>Moneda</th>
          <th>Período</th>
          <th>Monto Invertido</th>
          <th>Monto al día</th>
          <th>Variación parcial</th>
          <th>Ganancia total</th>
          <th colspan="3">
            <a class="fa-clickable" title="Nueva Inversión" v-b-modal.altaActivo>
              <i class="fas fa-plus text-success"></i>
            </a>
          </th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="activo in cartera" :key="activo.id">
          <td>{{activo.nombre}}</td>
          <td class="text-center">{{activo.moneda}}</td>
          <td class="text-center">
            <a class="fa-clickable" :title="activo.fechaInicial +  ' - ' + activo.fechaActual">
              <i class="fa fa-calendar text-success"></i>
            </a>
          </td>
          <td class="text-right">{{activo.montoInicial}}</td>
          <td class="text-right">{{activo.montoActual}}</td>

          <td class="text-right">{{activo.gananciaParcial}}</td>
          <td class="text-right">{{activo.gananciaTotal}}</td>

          <td class="text-center">
            <actualizacion-monto
              :idActivo="activo.id"
              :montoActual="activo.montoActual"
              @actualizarCartera="actualizarCartera"
            />
            <a
              class="fa-clickable"
              title="Actualizar Monto"
              v-b-modal="'actualizacion-monto' + activo.id"
            >
              <i class="fas fa-sync-alt text-secondary"></i>
            </a>
          </td>
          <td class="text-center">
            <a class="fa-clickable" title="Rescatar">
              <i class="fas fa-arrow-down text-danger"></i>
            </a>
          </td>
          <td class="text-center">
            <a class="fa-clickable" title="Invertir">
              <i class="fas fa-arrow-up text-primary"></i>
            </a>
          </td>
        </tr>
      </tbody>
    </table>
    <total-por-moneda :listaDeTotales="listaDeTotales" />
    <alta-activo :tipoMonedas="tipoMonedas" @activoNuevo="actualizarCartera" />
  </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from "vue-property-decorator";
import CotizacionDolar from "./CotizacionDolar.vue";
import ActualizacionMonto from "./ActualizacionMonto.vue";
import axios, { AxiosResponse } from "axios";
import AltaActivo from "./AltaActivo.vue";
import { Activo } from "../domain/Activo";
import TotalPorMoneda from "./TotalPorMoneda.vue";
import { Total } from "../domain/Total";

@Component({
  components: {
    CotizacionDolar,
    AltaActivo,
    ActualizacionMonto,
    TotalPorMoneda
  }
})
export default class Cartera extends Vue {
  private cartera: Array<Activo> = [];
  private tipoMonedas: Array<String> = [];
  private listaDeTotales: Array<Total> = [];

  created() {
    this.obtenerCartera();
    this.buscarTipoMonedas();
    this.buscarTotales();
  }

  actualizarCartera() {
    this.obtenerCartera();
    this.buscarTotales();
  }

  obtenerCartera() {
    axios
      .get("http://localhost:8097/api/cartera")
      .then((response: AxiosResponse<Array<Activo>>) => {
        this.cartera = response.data;
      });
  }

  buscarTipoMonedas() {
    axios
      .get("http://localhost:8097/api/tipo-moneda")
      .then((response: AxiosResponse<Array<String>>) => {
        this.tipoMonedas = response.data;
      });
  }

  buscarTotales() {
    axios
      .get("http://localhost:8097/api/detalle-activo")
      .then((response: AxiosResponse<Array<Total>>) => {
        this.listaDeTotales = response.data;
      });
  }
}
</script>

<style>
</style>
